package com.fuzamei.web;

import java.io.File;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.fuzamei.service.AccountMaintenanceService;
import com.fuzamei.utils.HashXiZhiUtil;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;

@Controller
@RequestMapping(value = "/AccountMaintenance")
public class AccountMaintenanceAction {
	@Autowired
	private AccountMaintenanceService  accountMaintenanceService;//注入service

	/**  
    *  账户开立 添加客户名称和银行账号  上传3份资料  分别插入  附件表  操作记录表，账户开立表
    *  需要完成【申请输】【账户承诺书】【其他凭证】3个文件的上传，插入账务开立表1条数据，插入附件表3条数据，还有插入操作历史1条数据)
    * @param  
    * @param   
    * @throws Exception  
    */
   @RequestMapping(value="/uploadOrInsertAccountMaintenance",method=RequestMethod.POST)  
   @ResponseBody  
   public Map<String,Object> uploadOrInsertBankAccount(@RequestParam("basic_data_id") MultipartFile file,
		@RequestParam("letter_of_commitment_id") MultipartFile file2 ,
   		@RequestParam("application_id") MultipartFile file3, HttpServletRequest request,
   	    @RequestParam("customer_name") String customer_name,
   	    @RequestParam("bank_account") String bank_account) throws IOException{
	   try {
		   String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\testCeshi";  
             File dir = new File(path);          
             if(!dir.exists()){  
                 dir.mkdirs();   
             }  
             Map<String, Object> map = new LinkedHashMap<String, Object>();
             map.put("customer_name", customer_name);  
             map.put("bank_account", bank_account);//可以不要  不输入参数   直接在service里put进去   后台插入要求格式以622707开头
		     //同时上传三个文件 应该对几个文件产生几个哈希值？？？？？？
             //其他凭证 
             String fileName = file.getOriginalFilename();  
             String pathFile=path+"/"+fileName;
             File newfile = new File(pathFile); 
             file.transferTo(newfile);
             map.put("basicAttachment_id", 1001);//附件id暂时写死
     		 map.put("basicAttachment_name", fileName);
     	     map.put("basicUrl","\\testCeshi"+fileName);
     	     
     	     //账户承诺书
    	     String fileName2 = file2.getOriginalFilename();  
             String pathFile2=path+"/"+fileName2;
             File newfile2 = new File(pathFile2); 
             file2.transferTo(newfile2);
             map.put("letterAttachment_id", 1002);//附件id暂时写死
    		 map.put("letterAttachment_name", fileName2);
    	     map.put("letterUrl","\\testCeshi"+fileName2);
    	     //开户申请书
        	 String fileName3 = file3.getOriginalFilename();  
             String pathFile3=path+"/"+fileName3;
             File newfile3 = new File(pathFile3); 
             file3.transferTo(newfile3);
             map.put("applicationAttachment_id", 1003);//附件id暂时写死
     	     map.put("applicationAttachment_name", fileName3);
     	     map.put("applicationUrl","\\testCeshi"+fileName3);
     	     

     	    accountMaintenanceService.insertIntoAccountINfo(map);//将经办支行提交的所有数据信息通过map传入service层先进行校验
     	   return JSONUtil.getJsonMap(200, true, "上传成功",null); //返回给前端一个map进行前段提示
	} catch (Exception e) {
		   return JSONUtil.getJsonMap(500, false, "上传出错"+e.getMessage(),null); //返回给前端一个map进行前段提示
	}
	
   }
   
   /**
    * 查询账户维护信息 列表
    * @param data
    * @return
    */
    @PostMapping(value = "/selectAccountMaintenanceInfo")//@PostMapping此注解 提交方式为post
	@ResponseBody
	public Map<String, Object> selectAccountMaintenanceInfo(@RequestBody String data) {
		//System.out.println("查询账户维护开立信息列表");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=accountMaintenanceService.selectAccountMaintenanceInfo(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作查询成功", pageDto);

		return mapResult;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
}
